#!/bin/bash
# Do not run this on your local machine. Instead, execute setup-tests.sh and it
# will automatically create, test, and tear down the testing environment.

set -e

apt-get update && apt-get install -y git wget curl build-essential python3 ffmpeg libcairo2-dev libpango1.0-dev libjpeg-dev libgif-dev librsvg2-dev
corepack enable
corepack prepare pnpm@latest --activate
git submodule update --init
pnpm run clean-all
pnpm install --frozen-lockfile
pnpm run build
pnpm run migrate
pnpm run --filter='!megalodon' test
pnpm run --filter=backend --filter=misskey-js lint
pnpm run --filter=frontend --filter=frontend-embed eslint
